# -*- coding: utf-8 -*-
from enigma import *
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ScrollLabel import ScrollLabel
from Components.GUIComponent import *
from Components.MenuList import MenuList
from Components.Input import Input
from Screens.Console import Console
from Plugins.Plugin import PluginDescriptor
from Screens.ImageWizard import ImageWizard
from enigma import eConsoleAppContainer

import os
import datetime
import gettext


enigma_version="Enigma2"
barryallen_path = "/media/ba"
barryallen_plugindir="/usr/lib/enigma2/python/Plugins/Extensions/BarryAllen" 
barryallen_localedir="%s/locale" % barryallen_path
barryallen_nobootmanager="%s/.banobootmanager" % barryallen_path
barryallen_language = "%s/.balanguage"  % barryallen_plugindir
barryallen_locked = "%s/.balocked" % barryallen_path
barryallen_imagelist = "/tmp/.baimages"
barryallen_downloads = "/tmp/.badownloads"
usr_script = "/usr/script"
timeport_usr_script = "/media/Timeport/usrscript"
barryallen_usr_script = "%s/script" % barryallen_path

try: 
   from Plugins.SystemPlugins.ConfigurationBackup.plugin import *
except:
   pass

os.environ['LANGUAGE']='en'
ba_language='en'

if os.path.exists("/etc/enigma2/settings") == True:
   f = open("/etc/enigma2/settings")
   line = f.readline()
   while (line):
	line = f.readline().replace("\n","")
	sp = line.split("=")
	if (sp[0] == "config.osd.language"):
	   sp2 = sp[1].split("_")
           ba_language = sp2[0]
           if os.path.exists("%s/%s" % (barryallen_localedir, ba_language)) == True:
              os.environ["LANGUAGE"] = sp[1]
           else:
              os.environ['LANGUAGE']='en'
              ba_language='en'
   f.close

if os.path.exists("/media/ba/locale") == True:
   _=gettext.Catalog('barryallen', '/media/ba/locale').gettext
if os.path.exists("%s/locale" % barryallen_plugindir) == True:
   _=gettext.Catalog('barryallen', barryallen_plugindir).gettext

###############################################################################
# CONFIG
###############################################################################

# versionstring, please do not change, if you do not release a new version
barryallen_version = "4.6.13"

# path to the standard readme-file
barryallen_readme = "%s/readme.txt" % barryallen_plugindir

# path to the barryallen.sh
barryallen_script = "%s/ba.sh" % barryallen_path

# path to the tmpfiles
barryallen_tmpfile = "/tmp/.batmp" 

# name of the imageinfofile
barryallen_infofile = "/.bainfo"

booted_image="Flash"
if os.path.exists(barryallen_infofile) == True:
   f = open(barryallen_infofile)
   booted_image = f.read()
   f.close()


# name of the MB image file
barryallen_mbimagepath = "/MB_Images"
if os.path.exists(barryallen_mbimagepath) == False:
   if (os.path.exists("/media/hdd/movie") == True) and (os.path.exists("/dev/ide/host0/bus0/target0/lun0") == True):
      # local harddisk found
      if os.path.exists("/media/hdd/MB_Images") == False:
         os.mkdir ("/media/hdd/MB_Images")
      try:
         os.symlink("/media/hdd/MB_Images","/MB_Images")
      except:
         pass
      barryallen_mbimagepath = "/media/hdd/MB_Images"
   else:
      # no local harddisk found
      if os.path.exists("/media/ba/MB_Images") == False:
         os.mkdir ("/media/ba/MB_Images")
      try:
         os.symlink("/media/ba/MB_Images","/MB_Images")
      except:
         pass
      barryallen_mbimagepath = "/media/ba/MB_Images"

def main(session,**kwargs):
    try:    
     	session.open(BarryAllenPlugin)
    except:
        print "[BARRYALLEN] Pluginexecution failed"

def autostart(reason,**kwargs):
    if reason == 0:
        print "[BARRYALLEN] no autostart"

def Plugins(**kwargs):
    try:
 	return [PluginDescriptor(name="Barry Allen", description=_("the second Flash"), where = PluginDescriptor.WHERE_PLUGINMENU, icon="barryallen.png", fnc=main),
			PluginDescriptor(name="Barry Allen", description=_("the second Flash"), where = PluginDescriptor.WHERE_EXTENSIONSMENU, icon="barryallen.png", fnc=main)]
    except:
        # for old images without Blue Button Extensions Menu
 	return [PluginDescriptor(name="Barry Allen", description=_("the second Flash"), where = PluginDescriptor.WHERE_PLUGINMENU, icon="barryallen.png", fnc=main)]

class BarryAllenPlugin(Screen):
    skin = """
        <screen position="120,150" size="450,230" title="Barry Allen Menu: %s" >
            <widget name="menu" position="10,10" size="440,220" scrollbarMode="showOnDemand" />
            <ePixmap position="345,125" size="100,100" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/BarryAllen/ba.png" transparent="1" alphatest="on" />	
        </screen>""" % booted_image

    def __init__(self, session, args = 0):
        self.skin = BarryAllenPlugin.skin
        self.session = session
        Screen.__init__(self, session)
        self.menu = args
        list = []
        list.append((_("Wizard for installed Images"), "changewizardba"))
        list.append((_("Wizard for Images at /MB_Images"), "manipulatewizardba"))
        list.append((_("Wizard for Debian"), "debianwizardba"))
        list.append((_("Wizard for Tools"), "toolswizardba"))
        list.append((_("Wizard for Setup"), "setupwizardba"))
        list.append((_("Multiboot Downloadcenter"), "downloadwizardba"))
        list.append((_("Barry Allen readme.txt"), "readmeba"))        
        list.append((_("about Barry Allen Version %s") % barryallen_version, "aboutba"))        
        self["menu"] = MenuList(list)
        self["actions"] = ActionMap(["WizardActions", "DirectionActions"],{"ok": self.go,"back": self.close,}, -1)
        
    def go(self):
        returnValue = self["menu"].l.getCurrentSelection()[1]
        if returnValue is not None:
           if returnValue is "changewizardba":
               ChangeWizardba(self.session)
           elif returnValue is "downloadwizardba":
               DownloadWizardba(self.session)
           elif returnValue is "manipulatewizardba":
               ManipulateWizardba(self.session)
           elif returnValue is "toolswizardba":
               ToolsWizardba(self.session)
           elif returnValue is "debianwizardba":
               DebianWizardba(self.session)
           elif returnValue is "setupwizardba":
               SetupWizardba(self.session)
           elif returnValue is "readmeba":
             if os.path.exists("%s/%s/LC_MESSAGES/readme.txt" % (barryallen_localedir,ba_language)) is True:
                self.session.open(Console,_("Barry Allen readme.txt"),["cat %s/%s/LC_MESSAGES/readme.txt" % (barryallen_localedir, ba_language) ])
             else:
                self.session.open(Console,_("Barry Allen readme.txt"),["cat %s" % barryallen_readme])
           elif returnValue is "aboutba":
             title1=_("Barry Allen %s Plugin %s by gutemine") % (enigma_version, barryallen_version)
             title2=_("Barry Allen kit download from www.oozoon.de")
             title3=_("Thanks for the Documentation by romeo-golf")
             title4=_("Thanks for supporting the PowerPC port:")
             title5=_("cali.s, krallekit, adenin, Hein Holz")
             title6=_("Thanks for the enigma1 plugin by DarkVolli")
             title7=_("Thanks for the Language translations:")
             title8=_("Czech by admin of dreamboxforum.eu")
             title9=_("Danish by jazzydane")
             title10=_("German by pewu")
             title11=_("Spanish by titovich")
             title12=_("French by mimi74")
             title13=_("Dutch by FeReNGi")
             title14=_("Italian by oldprogrammer and Spaeleus")
             title15=_("Swedish by hutten")
             title16=_("Portugese by Gotcha_GT")
             title="%s\n%s\n%s\n%s\n%s\n%s\n%s %s, %s, %s, %s, %s, %s, %s, %s, %s" % (title1, title2, title3, title4, title5, title6, title7, title8, title9, title10, title11, title12, title13, title14, title15, title16)
             self.session.open(MessageBox,("%s") % (title),  MessageBox.TYPE_INFO)


class ManipulateWizardba(Screen):
    def __init__(self, session):
        self.session = session
        self.askForManipulation()
        
    def askForManipulation(self):
        self.session.openWithCallback(self.askForSource,ChoiceBox,_("select command"),self.getManipulationList())

    def askForSource(self,manipulation):
        if manipulation is None:
            self.skipManipulation(_("command is NONE"))
        else:
            self.manipulate = manipulation [1].rstrip()
            self.source = ""
            self.target = ""
            if (self.manipulate == "list_nfi") or (self.manipulate == "list_bz2"):
               self.session.openWithCallback(self.ImageManipulate,MessageBox,_("executing %s %s %s ?") %(self.manipulate,self.source,self.target),MessageBox.TYPE_YESNO)
            elif (self.manipulate == "rename_nfi") or (self.manipulate == "remove_nfi") or (self.manipulate == "extract_nfi") or (self.manipulate == "flash_nfi"):
               self.session.openWithCallback(self.askForTarget,ChoiceBox,_("select SOURCE Image"), self.getListMB_Images(".nfi"))
            elif (self.manipulate == "rename_bz2") or (self.manipulate == "remove_bz2") or (self.manipulate == "extract_bz2") or (self.manipulate == "flash_bz2"):
               self.session.openWithCallback(self.askForTarget,ChoiceBox,_("select SOURCE Image"), self.getListMB_Images(".tar.bz2"))
        
    def askForTarget(self,source):
        if source is None:
            self.skipManipulation(_("SOURCE is NONE"))
        else:
            self.source = source [1].rstrip()
            if (self.manipulate == "remove_nfi") or (self.manipulate == "remove_bz2"):
               self.target = ""
               self.session.openWithCallback(self.ImageManipulate,MessageBox,_("executing %s %s %s ?") %(self.manipulate,self.source,self.target),MessageBox.TYPE_YESNO)
            elif (self.manipulate == "flash_nfi") or (self.manipulate == "flash_bz2") :
               self.target = "Flash"
               self.session.openWithCallback(self.ImageManipulate,MessageBox,_("extract of image %s restarts - OK ?") % self.source,MessageBox.TYPE_YESNO)
            else:
	       self.session.openWithCallback(self.askForDoManipulation,InputBox, title=_("Please enter name for TARGET Image"), text="%s                              " % self.source, maxSize=35, type=Input.TEXT)

    def askForDoManipulation(self,target):
        if target is None:
            self.skipManipulation(_("TARGET is NONE"))
        else:
            self.target = target.rstrip()
            if (self.manipulate == "extract_nfi"):
               self.session.openWithCallback(self.ImageManipulate,MessageBox,_("extract of image %s restarts - OK ?") % self.source,MessageBox.TYPE_YESNO)
            elif (self.manipulate == "extract_bz2"):
               self.session.openWithCallback(self.ImageManipulate,MessageBox,_("extract now image %s ?") % self.source,MessageBox.TYPE_YESNO)
            else:
               self.session.openWithCallback(self.ImageManipulate,MessageBox,_("executing %s %s %s ?") %(self.manipulate,self.source,self.target),MessageBox.TYPE_YESNO)
            
    def ImageManipulate(self,answer):
        if answer is None:
            self.skipManipulation(_("answer is NONE"))
        if answer is False:
            self.skipManipulation(_("you were not confirming"))
        else:
            title = _("executing %s %s %s") %(self.manipulate,self.source,self.target)
            cmd = "%s %s %s %s" % (barryallen_script,self.manipulate,self.source, self.target)
            self.session.open(Console,_(title),[cmd])
            
    def skipManipulation(self,reason):
        self.session.open(MessageBox,_("command was canceled, because %s") % reason, MessageBox.TYPE_ERROR)

    def getListMB_Images(self,endung):
        baimagemap = []
        sname = []
        bname = []
        if os.path.exists(barryallen_mbimagepath) == True:
           for name in os.listdir(barryallen_mbimagepath):
              if name.endswith(endung) is True: 
                 sname=name.split(endung)
                 if (endung == ".nfi"):
                    baimagemap.append(( sname[0], sname[0] ))
                 else: 
                    if name.startswith("MB_") is True:
                       bname=sname[0].split("MB_")
                       baimagemap.append(( bname[1], bname[1] ))
                    
        baimagemap.sort() 
        return baimagemap 

    def getManipulationList(self):
        manipul = []
        manipul.append((_("list nfi Images at /MB_Images"),"list_nfi"))
        manipul.append((_("list tar.bz2 Images at /MB_Images"),"list_bz2"))
        manipul.append((_("extract nfi Image from /MB_Images"),"extract_nfi"))
        manipul.append((_("extract tar.bz2 Image from /MB_Images"),"extract_bz2"))
#        manipul.append((_("flash nfi Image from /MB_Images"),"flash_nfi"))
#        manipul.append((_("flash tar.bz2 Image from /MB_Images"),"flash_bz2"))
        manipul.append((_("rename nfi Image at /MB_Images"),"rename_nfi"))
        manipul.append((_("rename tar.bz2 Image at /MB_Images"),"rename_bz2"))
        manipul.append((_("remove nfi Image from /MB_Images"),"remove_nfi"))
        manipul.append((_("remove tar.bz2 Image from /MB_Images"),"remove_bz2"))
        return manipul


class ToolsWizardba(Screen):
    def __init__(self, session):
        self.session = session
        self.askForToolsMenus()
        
    def askForToolsMenus(self):
            self.session.openWithCallback(self.askForTools,ChoiceBox,_("select tools submenu"),self.getMenuList())

    def askForTools(self,tools):
        if tools is None:
            self.skipTools(_("no submenu choosen"))
        else:
            self.tools = tools[1].rstrip()
            if self.tools is "restart":
                self.session.openWithCallback(self.askForCommand,ChoiceBox,_("select restart command"),self.getRestartList())
            elif self.tools is "fsck":
                self.session.openWithCallback(self.askForCommand,ChoiceBox,_("select Filesystemcheck command"),self.getFilesystemcheckList())
            elif self.tools is "erase":
                self.session.openWithCallback(self.askForCommand,ChoiceBox,_("select erase command"),self.getEraseList())
            elif self.tools is "install":
                self.session.openWithCallback(self.askForKit,ChoiceBox,_("select kit for install"),self.getInstallList())
            elif self.tools is "ipk_update":
                self.source = "ipk"
                self.kit = "update"
                self.session.openWithCallback(self.toolsCommand,MessageBox,_("are you sure to %s %s") %(self.source,self.kit), MessageBox.TYPE_YESNO)
            elif self.tools is "enable_boot_mount":
                self.source = "enable_boot_mount"
                self.kit = ""
                self.session.openWithCallback(self.toolsCommand,MessageBox,_("are you sure to %s") % self.source, MessageBox.TYPE_YESNO)
            elif self.tools is "disable_boot_mount":
                self.source = "disable_boot_mount"
                self.kit = ""
                self.session.openWithCallback(self.toolsCommand,MessageBox,_("are you sure to %s") % self.source, MessageBox.TYPE_YESNO)
            elif self.tools is "enable_dummy_boot_mount":
                self.source = "enable_dummy_boot_mount"
                self.kit = ""
                self.session.openWithCallback(self.toolsCommand,MessageBox,_("are you sure to %s") % self.source, MessageBox.TYPE_YESNO)
            elif self.tools is "disable_dummy_boot_mount":
                self.source = "disable_dummy_boot_mount"
                self.kit = ""
                self.session.openWithCallback(self.toolsCommand,MessageBox,_("are you sure to %s") % self.source, MessageBox.TYPE_YESNO)
            elif self.tools is "swap":
                self.session.openWithCallback(self.askForCommand,ChoiceBox,_("select swap command"),self.getSwapList())
            elif self.tools is "userscripts":
                UserscriptWizardba(self.session)
            elif self.tools is "configbackup":
                try:
                   self.session.open(BackupSetup)
                except:
                   self.session.open(MessageBox,_("Plugin not yet available"),  MessageBox.TYPE_INFO)

    def askForKit(self,source):
        if source is None:
            self.skipTools(_("no kit type selected"))
        else:
            self.source = source[1].rstrip()
            if self.source is "list_ipk":
                self.source = source
                self.askForCommand(self.source)
            elif self.source is "list_bz2":
                self.source = source
                self.askForCommand(self.source)
            elif self.source is "list_gz":
                self.source = source
                self.askForCommand(self.source)
            elif self.source is "list_rar":
                self.source = source
                self.askForCommand(self.source)
            elif self.source is "list_zip":
                self.source = source
                self.askForCommand(self.source)
            elif self.source is "ipk":
                os.system("%s list_ipk" % barryallen_script)
                self.session.openWithCallback(self.askForKitInstall,ChoiceBox,_("select kit"),self.getKitList())
            elif self.source is "bz2":
                os.system("%s list_bz2" % barryallen_script)
                self.session.openWithCallback(self.askForKitInstall,ChoiceBox,_("select kit"),self.getKitList())
            elif self.source is "gz":
                os.system("%s list_gz" % barryallen_script)
                self.session.openWithCallback(self.askForKitInstall,ChoiceBox,_("select kit"),self.getKitList())
            elif self.source is "zip":
                os.system("%s list_zip" % barryallen_script)
                self.session.openWithCallback(self.askForKitInstall,ChoiceBox,_("select kit"),self.getKitList())
            elif self.source is "rar":
                os.system("%s list_rar" % barryallen_script)
                self.session.openWithCallback(self.askForKitInstall,ChoiceBox,_("select kit"),self.getKitList())
                
    def askForKitInstall(self,kit):
        if kit is None:
            self.skipTools(_("no kit selected"))
        else:
            self.kit = kit[1].rstrip()
            self.session.openWithCallback(self.toolsCommand,MessageBox,_("are you sure to install %s") % self.kit, MessageBox.TYPE_YESNO)
            
    def askForCommand(self,source):
        if source is None:
            self.skipTools(_("no command passed"))
        else:
            self.source = source[1].rstrip()
            self.kit = ""
            self.session.openWithCallback(self.toolsCommand,MessageBox,_("are you sure to %s") % self.source, MessageBox.TYPE_YESNO)
            
    def toolsCommand(self,answer):
        if answer is None:
            self.skipTools(_("answer is None"))
        if answer is False:
            self.skipTools(_("you were not confirming"))
        else:
            if os.path.exists("/.bainfo") == True:
               os.system("cp /media/ba/bainit /sbin/bainit")
            if self.source is "restart":
               quitMainloop(3)
            elif self.source is "timerwrite":
                self.session.nav.RecordTimer.saveTimer()
                self.session.open(MessageBox,_("Timers were written to Flash") , MessageBox.TYPE_INFO)
            elif self.source is "erase_cf":
               title = _("executing CF card Erase")
               cmd = "/sbin/bainit 81" 
               self.session.open(Console,_(title),[cmd])
            elif self.source is "erase_usb":
               title = _("executing USB stick Erase")
               cmd = "/sbin/bainit 82" 
               self.session.open(Console,_(title),[cmd])
            elif self.source is "filesystemcheck_cf":
               title = _("executing CF card Filesystemcheck")
               cmd = "/sbin/bainit 91" 
               self.session.open(Console,_(title),[cmd])
            elif self.source is "filesystemcheck_cf_read":
               title = _("executing read only CF card Filesystemcheck")
               cmd = "/sbin/bainit 910" 
               self.session.open(Console,_(title),[cmd])
            elif self.source is "filesystemcheck_cf_fix":
               title = _("executing forced fix CF card Filesystemcheck")
               cmd = "/sbin/bainit 911" 
               self.session.open(Console,_(title),[cmd])
            elif self.source is "filesystemcheck_usb":
               title = _("executing USB stick Filesystemcheck")
               cmd = "/sbin/bainit 92" 
               self.session.open(Console,_(title),[cmd])
            elif self.source is "filesystemcheck_usb_read":
               title = _("executing read only USB stick Filesystemcheck")
               cmd = "/sbin/bainit 920" 
               self.session.open(Console,_(title),[cmd])
            elif self.source is "filesystemcheck_usb_fix":
               title = _("executing forced fix USB stick Filesystemcheck")
               cmd = "/sbin/bainit 921" 
               self.session.open(Console,_(title),[cmd])
            elif self.source is "filesystemcheck_hdd":
               title = _("executing Harddisk Filesystemcheck")
               cmd = "/sbin/bainit 93" 
               self.session.open(Console,_(title),[cmd])
            elif self.source is "filesystemcheck_hdd_read":
               title = _("executing read only Harddisk Filesystemcheck")
               cmd = "/sbin/bainit 930" 
               self.session.open(Console,_(title),[cmd])
            elif self.source is "filesystemcheck_hdd_fix":
               title = _("executing forced fix Harddisk Filesystemcheck")
               cmd = "/sbin/bainit 931" 
               self.session.open(Console,_(title),[cmd])
            else:
               title = _("executing command %s %s" %(self.source,self.kit))
               cmd = "%s %s %s"  % (barryallen_script,self.source,self.kit)
               self.session.open(Console,_(title),[cmd])
            
    def skipTools(self,reason):
        self.session.open(MessageBox,_("command was canceled, because %s") % reason, MessageBox.TYPE_ERROR)
        
    def getKitList(self):
        installkit = []
        
        if os.path.exists(barryallen_imagelist) is True:
           balist = open(barryallen_imagelist,"r")
           for line in balist:
              installkit.append(( line, line ))
           balist.close()

        return installkit

    def getMenuList(self):
        batools = []
        batools.append((_("restart options"),"restart"))
        batools.append((_("filesystemcheck CF, USB or HDD"),"fsck"))
        batools.append((_("erase CF or USB"),"erase"))
        batools.append((_("install and list kits from /tmp and /MB_Images"),"install"))
        batools.append((_("swap setup"),"swap"))
        batools.append((_("user scripts"),"userscripts"))
        batools.append((_("%s Configuration Backup/Restore") % enigma_version,"configbackup"))
        batools.append((_("%s Softwareupdate") % enigma_version,"ipk_update"))
        batools.append((_("enable /boot mount"),"enable_boot_mount"))
        batools.append((_("disable /boot mount"),"disable_boot_mount"))
        batools.append((_("enable dummy /boot mount"),"enable_dummy_boot_mount"))
        batools.append((_("disable dummy /boot mount"),"disable_dummy_boot_mount"))
        return batools

    def getRestartList(self):
        barestart = []
        barestart.append((_("reboot Dreambox"),"reboot"))
        barestart.append((_("halt Dreambox"),"halt"))
        barestart.append((_("restart %s on Dreambox") % enigma_version,"restart"))
        barestart.append((_("enable no %s restart") % enigma_version,"enable_no_restart"))
        barestart.append((_("disable no %s restart") % enigma_version,"disable_no_restart"))
        barestart.append((_("only write Timers to Flash") ,"timerwrite"))
        barestart.append((_("enable WebIF flashing"),"webflash"))
        return barestart

    def getFilesystemcheckList(self):
        bafsck = []
        bafsck.append((_("normal Filesystemcheck of CF Card"),"filesystemcheck_cf"))
        bafsck.append((_("read only Filesystemcheck of CF Card"),"filesystemcheck_cf_read"))
        bafsck.append((_("forced fix Filesystemcheck of CF Card"),"filesystemcheck_cf_fix"))
        bafsck.append((_("normal Filesystemcheck of USB Stick"),"filesystemcheck_usb"))
        bafsck.append((_("read only Filesystemcheck of USB Stick"),"filesystemcheck_usb_read"))
        bafsck.append((_("forced fix Filesystemcheck of USB Stick"),"filesystemcheck_usb_fix"))
        bafsck.append((_("normal Filesystemcheck of Harddisk"),"filesystemcheck_hdd"))
        bafsck.append((_("read only Filesystemcheck of Harddisk"),"filesystemcheck_hdd_read"))
        bafsck.append((_("forced fix Filesystemcheck of Harddisk"),"filesystemcheck_hdd_fix"))
        return bafsck

    def getEraseList(self):
        baerase = []
        baerase.append((_("CAUTION Erase of CF Card"),"erase_cf"))
        baerase.append((_("CAUTION Erase of USB Stick"),"erase_usb"))
        return baerase

    def getInstallList(self):
        bainstall = []
        bainstall.append((_("install ipk kit"),"ipk"))
        bainstall.append((_("install tar.bz2 kit"),"bz2"))
        bainstall.append((_("install tar.gz kit"),"gz"))
        bainstall.append((_("install rar kit"),"rar"))
        bainstall.append((_("install zip kit"),"zip"))
        bainstall.append((_("list ipk kits at /tmp and /MB_Images"),"list_ipk"))
        bainstall.append((_("list tar.bz2 kits at /tmp and /MB_Images"),"list_bz2"))
        bainstall.append((_("list tar.gz kits at /tmp and /MB_Images"),"list_gz"))
        bainstall.append((_("list rar kits at /tmp and /MB_Images"),"list_rar"))
        bainstall.append((_("list zip kits at /tmp and /MB_Images"),"list_zip"))
        return bainstall

    def getSwapList(self):
        baswap = []
        baswap.append((_("show memory"),"free"))
        es32="%s %s" %(_("enable swapfile"),"32MB")
        es64="%s %s" %(_("enable swapfile"),"64MB")
        es128="%s %s" %(_("enable swapfile"),"128MB")
        baswap.append((es32,"swapon /media/ba 32000"))
        baswap.append((es64,"swapon /media/ba 64000"))
        baswap.append((es128,"swapon /media/ba 128000"))
        baswap.append((_("disable swapfile"),"swapoff"))
        return baswap

class ChangeWizardba(Screen):
    def __init__(self, session):
        self.session = session
        self.askForChange()
        
    def askForChange(self):
        self.session.openWithCallback(self.askForSource,ChoiceBox,_("select command"),self.getChangeList())

    def askForSource(self,change):
        if change is None:
            self.skipChange(_("command is NONE"))
        else:
            self.change = change[1].rstrip()
            self.source = ""
            self.target = ""
            self.passwd = ""
            if self.change == "info":
               self.session.openWithCallback(self.ImageChange,MessageBox,_("executing %s %s %s ?") %(self.change,self.source,self.target),MessageBox.TYPE_YESNO)
            elif self.change == "short_info":
               self.session.openWithCallback(self.ImageChange,MessageBox,_("executing %s %s %s ?") %(self.change,self.source,self.target),MessageBox.TYPE_YESNO)
            elif self.change == "lock":
               self.session.openWithCallback(self.askForPassword,InputBox, title=_("Please enter PIN"), text="    ", maxSize=4, type=Input.PIN)
            else:
               if os.path.exists(barryallen_locked) == True:
   	          self.session.openWithCallback(self.askForPassword,InputBox, title=_("Please enter PIN"), text="    ", maxSize=4, type=Input.PIN)
	       else:
                  self.session.openWithCallback(self.askForTarget,ChoiceBox,_("select SOURCE Image"),self.getListInstalledImages())
            
    def askForPassword(self,passwd):
        if passwd is None:
           self.skipChange(_("PIN is NONE"))
        else:
           self.passwd = passwd.rstrip()
           if self.change == "lock":
              if os.path.exists(barryallen_locked) == True:
                 self.session.openWithCallback(self.ImageChange,MessageBox,_("are you sure to unlock Images with PIN %s ?") % self.passwd, MessageBox.TYPE_YESNO)
              else:
                 self.session.openWithCallback(self.ImageChange,MessageBox,_("are you sure to lock Images with PIN %s ?") % self.passwd, MessageBox.TYPE_YESNO)
           else:
              fp = open(barryallen_locked,"r")
              oldpasswd =fp.readline().rstrip()
              fp.close()
              if self.passwd == oldpasswd:
                 self.session.openWithCallback(self.askForTarget,ChoiceBox,_("select SOURCE Image"),self.getListInstalledImages())
              else:
                 self.skipChange(_("ERROR: PIN is wrong"))
               
    def askForTarget(self,source):
        if source is None:
            self.skipChange(_("SOURCE is NONE"))
        else:
            self.source = source[1].rstrip()
            if self.change == "boot":
               self.session.openWithCallback(self.ImageBoot,MessageBox,_("reboot ?"), MessageBox.TYPE_YESNO)
            elif (self.change == "delete") or (self.change == "image_mount") or (self.change == "image_umount"):
               self.session.openWithCallback(self.ImageChange,MessageBox,_("executing %s %s %s ?") %(self.change,self.source, self.target),MessageBox.TYPE_YESNO)
            else:
               if self.source == "booted":
                  self.target = "barryallenbackup_%s" % datetime.date.today()
               else:
                  self.target = self.source
               self.session.openWithCallback(self.processingChange,InputBox, title=_("Please enter name for TARGET Image"), text="%s                              " % self.target, maxSize=35, type=Input.TEXT)
            
    def processingChange(self,target):
        if target is None:
           self.skipChange(_("TARGET is NONE"))
        else:
           self.target= target.rstrip()
           if self.change == "backup_nfi":
              self.session.openWithCallback(self.ImageChange,MessageBox,_("backup of image %s restarts - OK ?") % self.source,MessageBox.TYPE_YESNO)
           elif self.change == "backup_bz2":
              self.session.openWithCallback(self.ImageChange,MessageBox,_("backup now image %s ?") % self.source,MessageBox.TYPE_YESNO)
           else:
              self.session.openWithCallback(self.ImageChange,MessageBox,_("executing %s %s %s ?") %(self.change,self.source,self.target),MessageBox.TYPE_YESNO)
              
    def ImageBoot(self,reboot):
        if reboot is None:
           self.skipChange(_("answer is NONE"))
        if reboot is False:
           self.target= ""
        else:
           self.target= "now"
        self.session.openWithCallback(self.ImageChange,MessageBox,_("executing %s %s %s ?") %(self.change,self.source,self.target),MessageBox.TYPE_YESNO)
            

    def ImageChange(self,answer):
        if answer is None:
            self.skipChange(_("answer is NONE"))
        if answer is False:
            self.skipChange(_("your were not confirming"))
        else:
            title = _("executing %s %s %s") %(self.change,self.source,self.target)
            cmd = "%s %s %s %s %s" % (barryallen_script,self.change,self.source,self.target,self.passwd)
            self.session.open(Console,_(title),[cmd])
            
    def skipChange(self,reason):
        self.session.open(MessageBox,_("command was canceled, because %s") % reason, MessageBox.TYPE_ERROR)

    def getListInstalledImages(self):
        imagesinstalled = []
        imagesinstalled2 = []
        if self.change == "copy":
            imagesinstalled.append(( "booted", "booted" ))
        elif (self.change == "boot") or (self.change == "image_mount") or (self.change == "image_umount"):
            imagesinstalled.append(( "Flash", "Flash" ))
        elif (self.change == "backup_nfi") or (self.change == "backup_bz2"):
            imagesinstalled.append(( "booted", "booted" ))
        for line in os.listdir("/media/ba/ba"):
            if line.startswith(".") is False: 
               if line != "Flash":
                  imagesinstalled2.append(( line, line ))
        imagesinstalled2.sort()
        imagesinstalled = imagesinstalled + imagesinstalled2
        return imagesinstalled

    def getChangeList(self):
        change = []
        change.append((_("installed Images info"), "info"))
        change.append((_("installed Images short info"), "short_info"))
        change.append((_("select installed Image for booting"), "boot"))
        change.append((_("delete installed Image"),"delete"))
        change.append((_("rename installed Image"),"name"))
        change.append((_("copy installed Image"),"copy"))
        f = open("/proc/cpuinfo")
        cputype = f.read()
        f.close()
        if cputype.find("XILLEON") is not -1:
           change.append((_("mount installed Image"),"image_mount"))
           change.append((_("unmount installed Image"),"image_umount"))
        change.append((_("backup  Image to nfi Image at /MB_Images"),"backup_nfi"))
        change.append((_("backup  Image to tar.bz2 Image at /MB_Images"),"backup_bz2"))
        change.append((_("switch Image lock"),"lock"))
        return change


class DownloadWizardba(Screen):
    def __init__(self, session):

        self.session = session
        self.session.openWithCallback(self.DownloadSelected,ChoiceBox,_("select for download"),self.getListDownloads())        

    def DownloadSelected(self,command):
        if command is None:
            self.skipDownloadselect(_("no download selected"))
        else:
            self.target = command[1]
            self.session.openWithCallback(self.setDownload,MessageBox,_("are you sure to %s ?") % self.target, MessageBox.TYPE_YESNO)

    def setDownload(self,answer):
        if answer is None:
            self.skipDownloadselect(_("answer is None"))
        elif answer is False:
            self.skipDownloadselect(_("you were not confirming"))
        else:
           if self.target is "list":
              self.session.open(Console,_("executing command %s %s") % (self.target,""),["%s %s" % (barryallen_script,self.target)])
           elif self.target is "wupdate":
              self.session.open(Console,_("executing command %s %s") % (self.target,""),["%s %s" % (barryallen_script,self.target)])
           elif self.target is "secondstage_remove":
              self.session.open(Console,_("executing command %s %s") % (self.target,""),["%s %s" % (barryallen_script,self.target)])
           else:
              self.session.open(Console,_("Downloading %s") % self.target,["%s wget %s" % (barryallen_script,self.target)])

    def skipDownloadselect(self,reason):
        self.session.open(MessageBox,_("selecting a download was cancelled, because %s") % reason, MessageBox.TYPE_ERROR)

    def getListDownloads(self):
        downloadmap = []
        downloadmap.append((_("list /MB_Images" ),"list"))
        downloadmap.append((_("get updated list"),"wupdate"))
        if os.path.exists("/MB_Images/secondstage.gz") is True:
           downloadmap.append((_("remove /MB_Images/secondstage.gz"),"secondstage_remove"))

        os.system("%s wlist" % barryallen_script)
        
        if os.path.exists(barryallen_downloads) is True:
           balist = open(barryallen_downloads,"r")
           for line in balist:
              downloadmap.append(( line, line ))
           balist.close()

        return downloadmap

class UserscriptWizardba(Screen):
    def __init__(self, session):

        self.session = session
        self.session.openWithCallback(self.UserscriptSelect,ChoiceBox,_("select userscript"),self.getListUserscript())        

    def UserscriptSelect(self,command):
        if command is None:
            self.skipUserscriptselect(_("no user script selected"))
        else:
            self.target = command[1].rstrip()
            print "!%s!" % self.target
            self.session.openWithCallback(self.UserscriptSelected,ChoiceBox,_("select userscript option"),self.getListUserscriptOption())        

    def UserscriptSelected(self,command):
        if command is None:
            self.skipUserscriptselect(_("no user script selected"))
        else:
            self.option = command[1].rstrip()
            if self.option == "userdefined":
	       self.session.openWithCallback(self.askForUserscriptOption,InputBox, title=_("Please enter option for %s") % self.target, text="restart", maxSize=35, type=Input.TEXT)
            else:
               self.session.openWithCallback(self.setUserscript,MessageBox,_("are you sure to %s %s?") %(self.target,self.option), MessageBox.TYPE_YESNO)

    def askForUserscriptOption(self,option):
        if option is None:
            self.skipUserscriptselect(_("option is none"))
        else:
            self.option = option.rstrip()
            self.session.openWithCallback(self.setUserscript,MessageBox,_("are you sure to %s %s?") %(self.target,self.option), MessageBox.TYPE_YESNO)

    def setUserscript(self,answer):
        if answer is None:
            self.skipUserscriptselect(_("answer is None"))
        elif answer is False:
            self.skipUserscriptselect(_("you were not confirming"))
        else:
            self.session.open(Console,_("executing user script %s %s") % (self.target,self.option),["%s %s" % (self.target,self.option)])

    def skipUserscriptselect(self,reason):
        self.session.open(MessageBox,_("selecting a user script was cancelled, because %s") % reason, MessageBox.TYPE_ERROR)

    def getListUserscript(self):
        userscriptmap = []
        for name in os.listdir(barryallen_usr_script):
           if name.endswith(".sh") is True:
              userscriptmap.append(( name, "%s/%s" % (barryallen_usr_script,name) ))
        if os.path.exists(usr_script) == True:
           for name in os.listdir(usr_script):
              if name.endswith(".sh") is True:
                 userscriptmap.append(( name, "%s/%s" % (usr_script,name) ))
        if os.path.exists(timeport_usr_script) == True:
           for name in os.listdir(timeport_usr_script):
              if name.endswith(".sh") is True:
                 userscriptmap.append(( name, "%s/%s" % (timeport_usr_script,name) ))

        return userscriptmap

    def getListUserscriptOption(self):
        userscriptoption = []
        userscriptoption.append(( "none", " " ))
        userscriptoption.append(( "start", "start" ))
        userscriptoption.append(( "stop", "stop" ))
        userscriptoption.append(( "restart", "restart" ))
        userscriptoption.append(( "info", "info" ))
        userscriptoption.append(( "enable", "enable" ))
        userscriptoption.append(( "disable", "disable" ))
        userscriptoption.append(( "userdefined:", "userdefined" ))
        return userscriptoption


class SetupWizardba(Screen):
    def __init__(self, session):
        self.session = session
        self.askForSetupMenus()
        
    def askForSetupMenus(self):
            self.session.openWithCallback(self.askForSetup,ChoiceBox,_("select setup submenu"),self.getSetupList())

    def askForSetup(self,setup):
        if setup is None:
            self.skipSetup(_("no submenu choosen"))
        else:
            self.setup = setup[1].rstrip()
            self.kit=""
            if self.setup is "driver":
                self.session.openWithCallback(self.askForSetupCommand,ChoiceBox,_("select driver command"),self.getDriverList())
            elif self.setup is "rcdevice":
                self.session.openWithCallback(self.askForSetupCommand,ChoiceBox,_("select RC device command"),self.getRCDeviceList())
            elif self.setup is "shared":
                self.session.openWithCallback(self.askForSetupCommand,ChoiceBox,_("select shared command"),self.getSharedList())
            elif self.setup is "link":
                self.session.openWithCallback(self.askForSetupCommand,ChoiceBox,_("select link command"),self.getLinkList())
            elif self.setup is "language":
                self.session.openWithCallback(self.askForSetupCommand,ChoiceBox,_("select language command"),self.getLanguageList())
            elif self.setup is "color":
                self.session.openWithCallback(self.askForSetupCommand,ChoiceBox,_("select boot color mode"),self.getColorModesList())
            elif self.setup is "resolution":
                self.session.openWithCallback(self.askForSetupCommand,ChoiceBox,_("select boot resolution"),self.getResolutionList())
            else:
                self.session.openWithCallback(self.setupCommand,MessageBox,_("are you sure to %s") % self.setup, MessageBox.TYPE_YESNO)

    def askForSetupCommand(self,setup):
        if setup is None:
            self.skipSetup(_("no command passed"))
        else:
            self.setup = setup[1].rstrip()
            self.session.openWithCallback(self.setupCommand,MessageBox,_("are you sure to %s") % self.setup, MessageBox.TYPE_YESNO)
            
    def setupCommand(self,answer):
        if answer is None:
            self.skipSetup(_("answer is None"))
        if answer is False:
            self.skipSetup(_("you were not confirming"))
        else:
            self.kit=""
            title = _("executing command %s %s") %(self.setup,self.kit)
            cmd = "%s %s %s"  % (barryallen_script,self.setup,self.kit)
            self.session.open(Console,_(title),[cmd])
            
    def skipSetup(self,reason):
        self.session.open(MessageBox,_("command was canceled, because %s") % reason, MessageBox.TYPE_ERROR)
        

    def getSetupList(self):
        ls="Shell Script "+_("language setup")
        basetup = []
        basetup.append((_("driver load"),"driver"))
        basetup.append((_("RC device"),"rcdevice"))
        basetup.append((_("bapostinst, sharing and copy options"),"shared"))
        basetup.append((_("/MB_Images link setup"),"link"))
        basetup.append((_("patch %s") % enigma_version,"patch"))
        basetup.append((_("add Webinterface if missing"),"add_webif"))
        basetup.append((ls,"language"))
        basetup.append((_("boot color mode setup"),"color"))
        f = open("/proc/cpuinfo")
        cputype = f.read()
        f.close()
        if cputype.find("XILLEON") is -1:
           basetup.append((_("boot resolution setup"),"resolution"))
        if os.path.exists(barryallen_nobootmanager) == True:
           basetup.append((_("enable bootmanager"),"enable_bootmanager"))
        else:
           basetup.append((_("disable bootmanager"),"disable_bootmanager"))
        for name in os.listdir(barryallen_path):
           if name.endswith(".mvi") is True: 
              if name <> "barryallen.mvi": 
                 # rstrip(".mvi") doesn't work hence split
                 sname=name.split(".mvi")
                 basetup.append(( "bootlogo %s" % sname[0], "bootlogo %s" % sname[0] ))
        return basetup

    def getRCDeviceList(self):
        badevice = []
        badevice.append((_("/dev/input/event0"),"device /dev/input/event0"))
        badevice.append((_("/dev/input/event1"),"device /dev/input/event1"))
        badevice.append((_("/dev/input/event2"),"device /dev/input/event2"))
        badevice.append((_("default"),"device default"))
        return badevice

    def getDriverList(self):
        badriver = []
        badriver.append((_("load USB drivers"),"usbdriver"))
        badriver.append((_("ifconfig"),"ifconfig"))
        badriver.append((_("ifup"),"ifup"))
        badriver.append((_("ifdown"),"ifdown"))
        badriver.append((_("netstat"),"netstat"))
        badriver.append((_("force Kernel and Drivers onto Flash"),"flash_force"))
        f = open("/proc/cpuinfo")
        cputype = f.read()
        f.close()
        if cputype.find("XILLEON") is not -1:
           if os.path.exists("/media/ba/.bakeepsquashfs") == False:
              badriver.append((_("keep squashfs of OE 1.5 images"),"enable_squashfs"))
           else:
              badriver.append((_("do not keep squashfs of OE 1.5 images"),"disable_squashfs"))
        return badriver

    def getSharedList(self):
        bashared = []
        if os.path.exists("/media/ba/bapostinst") == True:
           bashared.append((_("deactivate bapostinst"),"disable_bapostinst"))
        else:
           for name in os.listdir(barryallen_path):
              if name.endswith(".template") is True: 
                 if name.startswith("ba") is True: 
                    bashared.append((_("activate %s" % name),"enable_bapostinst %s" % name))
        bashared.append((_("copy automount.conf local to shared"),"copy_automount_local_to_shared"))
        bashared.append((_("copy automount.conf shared to local"),"copy_automount_shared_to_local"))
        bashared.append((_("copy timers.xml local to shared"),"copy_timers_local_to_shared"))
        bashared.append((_("copy timers.xml shared to local"),"copy_timers_shared_to_local"))
        bashared.append((_("enable shared timers.xml"),"enable_shared_timers"))
        bashared.append((_("disable shared timers.xml"),"disable_shared_timers"))
#       bashared.append((_("enable shared epg.dat"),"enable_shared_epg"))
#       bashared.append((_("disable shared epg.dat"),"disable_shared_epg"))
        bashared.append((_("backup all shared files"),"shared backup"))
        bashared.append((_("restore all shared files"),"shared restore"))
        return bashared
        
    def getLinkList(self):
        balink = []
        balink.append((_("link to /media/hdd/MB_Images"),"link /media/hdd"))
        balink.append((_("link to /media/cf/MB_Images"),"link /media/cf"))
        balink.append((_("link to /media/usb/MB_Images"),"link /media/usb"))
        return balink

    def getLanguageList(self):
        balanguage = []
        balanguage.append((_("display current language"),"language"))
        balanguage.append((_("switch to language cs"),"language cs"))
        balanguage.append((_("switch to language da"),"language da"))
        balanguage.append((_("switch to language de"),"language de"))
        balanguage.append((_("switch to language en"),"language en"))
        balanguage.append((_("switch to language es"),"language es"))
        balanguage.append((_("switch to language fr"),"language fr"))
        balanguage.append((_("switch to language it"),"language it"))
        balanguage.append((_("switch to language nl"),"language nl"))
#       balanguage.append((_("switch to language ru"),"language ru"))
        balanguage.append((_("switch to language pt"),"language pt"))
        balanguage.append((_("switch to language sv"),"language sv"))
        return balanguage


    def getColorModesList(self):
        colormenu = []
        cf = open("/proc/stb/avs/0/colorformat_choices","r")
        line =cf.readline()
        cf.close()
        colors=line.split(" ")
        for color in colors:
           colormenu.append(( color.upper(), "color %s" % color ))
        colormenu.append(( "NONE", "color none" ))
        return colormenu
        
    def getResolutionList(self):
        resolutionmenu = []
        rf = open("/proc/stb/video/videomode_choices","r")
        line =rf.readline()
        rf.close()
        resolutions=line.split(" ")
        for resolution in resolutions:
           resolutionmenu.append(( resolution, "resolution %s" % resolution ))
        resolutionmenu.append(( "NONE", "resolution none" ))
        return resolutionmenu


class DebianWizardba(Screen):
    def __init__(self, session):
        self.session = session
        self.session.openWithCallback(self.askForDebian,ChoiceBox,_("select command"),self.getDebianList())

    def askForDebian(self,debian):
        if debian is None:
            self.skipDebian(_("command is NONE"))
        else:
            self.debian = debian[1].rstrip()
            self.target = ""
            if (self.debian == "extract_debian"):
	       self.session.openWithCallback(self.askForDebianTarget,InputBox, title=_("Please enter name for TARGET Image"), text="debian                             ", maxSize=35, type=Input.TEXT)
        
    def askForDebianTarget(self,target):
        if target is None:
            self.skipDebian(_("TARGET is NONE"))
        else:
            self.target = target.rstrip()
            if (self.debian == "extract_debian"):
               self.session.openWithCallback(self.DoDebian,MessageBox,_("executing %s %s ?") %(self.debian,self.target),MessageBox.TYPE_YESNO)
            
    def DoDebian(self,answer):
        if answer is None:
            self.skipDebian(_("answer is NONE"))
        if answer is False:
            self.skipDebian(_("you were not confirming"))
        else:
            title = _("executing %s %s") %(self.debian,self.target)
            cmd = "%s %s %s" % (barryallen_script,self.debian, self.target)
            self.session.open(Console,_(title),[cmd])
            
    def skipDebian(self,reason):
        self.session.open(MessageBox,_("command was canceled, because %s") % reason, MessageBox.TYPE_ERROR)

    def getDebianList(self):
        manipul = []
        manipul.append((_("install Debian Linux"),"extract_debian"))
        return manipul


