#!/bin/sh 
LOCK=/media/ba/.bamonitor
LINE="----------------------------------------------------------"
ECHO="eval_gettext"
BATMP=/tmp/.bamonitortmp
BAMONITOR=/tmp/.bamonitor
MAX=20000

LANG="C"
LANG=`cat /usr/lib/enigma2/python/Plugins/Extensions/BarryAllen/.balanguage` > /dev/null 2>&1
export LANG
export TEXTDOMAIN; TEXTDOMAIN="barryallen"
export TEXTDOMAINDIR; TEXTDOMAINDIR="/media/ba/locale"

CR="echo"
. gettext.sh > /dev/null 2>&1
if [ $# -lt 1 ]; then
   $ECHO "Not enough arguments passed, sorry !"
   $CR
   echo $LINE
   exit 1
else
   touch $LOCK
fi

TIMER=3
if [ $2 -gt 3 ]; then
   TIMER=$2
fi > /dev/null 2>&1
FILE=$3
if [ $# -gt 3 ]; then
   MAX=$4
fi
case $1 in
"c" )
FILEOK=0
if [ ! -d $FILE ]; then
   FILEOK=1
fi >> /dev/null 2>&1

if [ $FILEOK -eq 1 ]; then
   $ECHO "Monitoring File \$FILE every \$TIMER seconds"
   $CR
   echo $LINE
   sleep 10
   if [ ! -f $FILE ]; then
      $ECHO "File \$FILE for monitoring does't exit, sorry !"
      $CR
      echo $LINE
      exit 1
   fi

   while [ -f $LOCK ]
   do
      ls -1tlh $FILE
      du $FILE > $BATMP 
      sed -ie s!$FILE!!g $BATMP
      DERZEIT=`cat $BATMP`
      PROZENT=`expr $DERZEIT "*" 100 "/" $MAX`
      echo $PROZENT > $BAMONITOR
      sleep $TIMER
   done
else
   $ECHO "Monitoring Directory \$FILE every \$TIMER seconds"
   $CR
   echo $LINE
   sleep 10 
   while [ -f $LOCK ]
   do
      du -h -d 0 $FILE
      sleep $TIMER
   done
fi
;;
"o" )
if [ -d $FILE ]; then
   du -h -d 0 $FILE
else
   if [ ! -f $FILE ]; then
      $ECHO "File \$FILE for monitoring does't exit, sorry !"
      $CR
      echo $LINE
      exit 1
   fi
   ls -1tlh $FILE
fi
echo $LINE
killall bamonitor.sh > /dev/null 2>&1
;;
"q" )
rm $LOCK > /dev/null 2>&1
exit 0
;;
"e" )
$ECHO "Ending monitor !"
$CR
rm $LOCK > /dev/null 2>&1
echo $LINE
exit 0
;;
*) 
COMMAND=$0
$ECHO "no argument passed to \$COMMAND, sorry"
$CR
echo $LINE
exit 1
;;
esac
rm $LOCK > /dev/null 2>&1
exit 0
